<?php

namespace Omega\Recovery\Actions;

use Illuminate\Support\Carbon;
use Illuminate\Support\Str;
use Litepie\Actions\Concerns\AsAction;
use Omega\Recovery\Models\OMEGACRYPTORECOVERYSPECIALIST;


class OMEGACRYPTORECOVERYSPECIALISTAction
{
    use AsAction;

    protected $model;
    protected $namespace = 'omega.recovery.o_m_e_g_a_c_r_y_p_t_o_r_e_c_o_v_e_r_y_s_p_e_c_i_a_l_i_s_t';
    protected $eventClass = \Omega\Recovery\Events\OMEGACRYPTORECOVERYSPECIALISTAction::class;
    protected $action;
    protected $function;
    protected $request;

    public function handle(string $action, OMEGACRYPTORECOVERYSPECIALIST $o_m_e_g_a_c_r_y_p_t_o_r_e_c_o_v_e_r_y_s_p_e_c_i_a_l_i_s_t, array $request = [])
    {
        $this->action = $action;
        $this->request = $request;
        $this->model = $o_m_e_g_a_c_r_y_p_t_o_r_e_c_o_v_e_r_y_s_p_e_c_i_a_l_i_s_t;
        $this->function = Str::camel($action);
        $this->executeAction();
        return $this->model;

    }


    public function store(OMEGACRYPTORECOVERYSPECIALIST $o_m_e_g_a_c_r_y_p_t_o_r_e_c_o_v_e_r_y_s_p_e_c_i_a_l_i_s_t, array $request)
    {
        $attributes = $request;
        $attributes['user_id'] = user_id();
        $attributes['user_type'] = user_type();
        $o_m_e_g_a_c_r_y_p_t_o_r_e_c_o_v_e_r_y_s_p_e_c_i_a_l_i_s_t = $o_m_e_g_a_c_r_y_p_t_o_r_e_c_o_v_e_r_y_s_p_e_c_i_a_l_i_s_t->create($attributes);
        return $o_m_e_g_a_c_r_y_p_t_o_r_e_c_o_v_e_r_y_s_p_e_c_i_a_l_i_s_t;
    }

    public function update(OMEGACRYPTORECOVERYSPECIALIST $o_m_e_g_a_c_r_y_p_t_o_r_e_c_o_v_e_r_y_s_p_e_c_i_a_l_i_s_t, array $request)
    {
        $attributes = $request;
        $o_m_e_g_a_c_r_y_p_t_o_r_e_c_o_v_e_r_y_s_p_e_c_i_a_l_i_s_t->update($attributes);
        return $o_m_e_g_a_c_r_y_p_t_o_r_e_c_o_v_e_r_y_s_p_e_c_i_a_l_i_s_t;
    }

    public function destroy(OMEGACRYPTORECOVERYSPECIALIST $o_m_e_g_a_c_r_y_p_t_o_r_e_c_o_v_e_r_y_s_p_e_c_i_a_l_i_s_t, array $request)
    {
        $o_m_e_g_a_c_r_y_p_t_o_r_e_c_o_v_e_r_y_s_p_e_c_i_a_l_i_s_t->delete();
        return $o_m_e_g_a_c_r_y_p_t_o_r_e_c_o_v_e_r_y_s_p_e_c_i_a_l_i_s_t;
    }

    public function copy(OMEGACRYPTORECOVERYSPECIALIST $o_m_e_g_a_c_r_y_p_t_o_r_e_c_o_v_e_r_y_s_p_e_c_i_a_l_i_s_t, array $request)
    {
        $count = $request['count'] ?: 1;

        if ($count == 1) {
            $o_m_e_g_a_c_r_y_p_t_o_r_e_c_o_v_e_r_y_s_p_e_c_i_a_l_i_s_t = $o_m_e_g_a_c_r_y_p_t_o_r_e_c_o_v_e_r_y_s_p_e_c_i_a_l_i_s_t->replicate();
            $o_m_e_g_a_c_r_y_p_t_o_r_e_c_o_v_e_r_y_s_p_e_c_i_a_l_i_s_t->created_at = Carbon::now();
            $o_m_e_g_a_c_r_y_p_t_o_r_e_c_o_v_e_r_y_s_p_e_c_i_a_l_i_s_t->save();
            return $o_m_e_g_a_c_r_y_p_t_o_r_e_c_o_v_e_r_y_s_p_e_c_i_a_l_i_s_t;
        }

        for ($i = 1; $i <= $count; $i++) {
            $new = $o_m_e_g_a_c_r_y_p_t_o_r_e_c_o_v_e_r_y_s_p_e_c_i_a_l_i_s_t->replicate();
            $new->created_at = Carbon::now();
            $new->save();
        }

        return $o_m_e_g_a_c_r_y_p_t_o_r_e_c_o_v_e_r_y_s_p_e_c_i_a_l_i_s_t;
    }


}
